#include "matrix.h"
#include "mex.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "bvBasicFunctions.h"

/*************************
 * bvToolbox  Copyright (C) 2013  PIERRE Fabien (read license.txt)
 * Auteur 	: Fabien PIERRE.
 * Version	:	1.1.
 * Date	    : 30 mai 2013.
*/

void gradient(double * image_initiale, double *gradient_x, double *gradient_y, int height, int width )
{
    int N;
    int col, lin;
    N=width*height;
    for(col=0; col<width; col++)
    {
        for(lin=0; lin<height; lin++)
        {
            if(lin==(height-1))
            {
                gradient_x[lin+col*height]=0;
            }
            else
            {
                gradient_x[lin+col*height]=
                        image_initiale[lin+(col)*height+1]
                        -image_initiale[lin+col*height];
            }
            if((col==(width-1)))
            {
                gradient_y[lin+col*height]= 0;
            }
            else
            {
                gradient_y[lin+col*height]=
                        image_initiale[lin+(col+1)*height]
                        -image_initiale[lin+col*height];
            }
        }
    }
}


void divergence(double *gradient_x, double *gradient_y, double * result, int height, int width )
{
    int col, lin;
    double x_1;
    double x_2;
    int N;
    N=width*height;
    for(lin=0; lin<height; lin++)
    {
        for(col=0; col<width; col++)
        {
            if(lin==0)
            {
                x_1=gradient_x[lin+height*col];
            }
            else if (lin==(height-1))
            {
                x_1=-gradient_x[lin+height*col-1];
            }
            else
            {
                x_1=gradient_x[lin+height*col]
                        -gradient_x[lin+height*col-1];
            }
            
            if (col==0)
            {
                x_2=gradient_y[lin+height*col];
            }
            else if (col==(width-1))
            {
                x_2=-gradient_y[lin+height*(col-1)];
            }
            else
            {
                x_2=gradient_y[lin+height*col]
                        -gradient_y[lin+height*(col-1)];
            }
            result[lin+height*col]= x_1+x_2;
        }
    }
}


double getNormI(double * a, double * b, int height, int width )
{
    int i;
    double temp;
    double m_rel=0;
    int N;
    N=width*height;
    for(i=0; i<N; i++)
    {
        temp=sqrt(a[i]*a[i] + b[i]*b[i]);
        if(temp > m_rel)
        {
            m_rel=temp;
        }
    }
    return m_rel;
}
