function I_result = bvProximalOperator( Im, N, tau )
%bvProximalOperator Calcule l'operateur proximal de la variation totale.
%   I = bvProximalOperator( Im, N, tau )
%   
%   Im : Image dont on cherche la projection.
%   N : Nombre d'itrations de l'algorithme  point fixe (Cf Chambolle).
%   tau : variable de l'oprateur proximal.
%
% $$ I_result= \left( I_d + \tau \partial J \right)^{-1}(Im) \text{ , }$$
% o $J$ represente la variation totale de l'image.
%
%   Nota Bene : Pour les applications critiques en puissance utilisez la
%   fonction avec le suffixe '_mex' :
%   I_result = bvProximalOperator_mex(Im, N, tau );
%
%   !! MISE EN GARDE : Les arguments de cette fonction doivent tre passs
%   en format 'double' sans quoi une erreur de segmentation peut apparaitre
%   lors de l'appel de la fonction mex.

% bvToolbox  Copyright (C) 2013  PIERRE Fabien (read license.txt)
% Auteur 	: Fabien PIERRE.
% Version	: 1.1
% Date      : 30 mai 2013.
%

I_result = bvProximalOperator_mex(double(Im), N, double(tau) );
end
