function x = inpainting_chambolle_FB_BT( g , N, sigma,iterations_gradient,mask)
% x = inpainting_chambolle_FB_BT( g , N, sigma,iterations_gradient,mask)

% bvToolbox  Copyright (C) 2013  PIERRE Fabien (read license.txt)
% Auteur 	: Fabien PIERRE.
% Version	: 1.1
% Date      : 30 mai 2013.
%

lambda=sigma/4;
v=zeros(size(g));
beta=0.6;

x=v;
z=x;
t=1;

for itt=1:N
    y=g.*mask*1/(lambda*beta)+(ones(size(mask))-mask*1/(lambda*beta)).*z;
    x_1=bvProximalOperator(y, iterations_gradient, lambda/beta);
    t_1=(1+sqrt(4*t^2+1))/2;
    lambda_n=1+(t-1)/t_1;
    t=t_1;
    z=x+lambda_n*(x_1-x);
    x=x_1;
end

end