#include "matrix.h"
#include "mex.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "bvBasicFunctions.h"

/*************************
 * bvToolbox  Copyright (C) 2013  PIERRE Fabien (read license.txt)
 * Auteur 	: Fabien PIERRE.
 * Version	:	1.1.
 * Date	    : 30 mai 2013.
*/

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    /* Declarations.*/
    double *result, *gradient_x, *gradient_y;
    int height, width, ndim ;
    const int *dims;
    
    if(nrhs!=2) {
        mexErrMsgIdAndTxt("bvToolbox:bvDivergence:nrhs","2 inputs required.");
    }
    if(nlhs!=1) {
        mexErrMsgIdAndTxt("bvToolbox:bvDivergence:nlhs","One output required.");
    }
    
    /*gestion entrees-sorties.*/
    ndim= mxGetNumberOfDimensions(prhs[0]);
    dims= mxGetDimensions(prhs[0]);
    height = dims[0];
    width = dims[1];
    
    gradient_x = (double*)mxGetPr(prhs[0]);
    gradient_y = (double*)mxGetPr(prhs[1]);
    
    plhs[0]= mxCreateNumericArray(ndim, dims, mxDOUBLE_CLASS, mxREAL);
    result= (double*)mxGetPr(plhs[0]);
    
    /*Calcul de la divergence.*/
    divergence(gradient_x, gradient_y, result, height, width );
    
    return;
}
